-- Author      : Skylar State
-- Last Updated : 7/16/2012 01:45 AM

local SkyUI = SkyUI
local SkyBaseClass = SkyBaseClass



local SkyUnitFrame = SkyUI_CreateClass(SkyBaseClass)

SkyUnitFrame.prototype.Name = nil
SkyUnitFrame.prototype.F = nil -- Frame

SkyUnitFrame.prototype.RT = 0 -- RelativeTo Position
SkyUnitFrame.prototype.X = 0
SkyUnitFrame.prototype.Y = 0
SkyUnitFrame.prototype.W = 0
SkyUnitFrame.prototype.H = 0

SkyUnitFrame.prototype.Unit = nil
SkyUnitFrame.prototype.GUID = nil
SkyUnitFrame.prototype.Health = 0
SkyUnitFrame.prototype.Power = 0
SkyUnitFrame.prototype.TargetGUID = nil
SkyUnitFrame.prototype.TexturesReversed = nil

SkyUnitFrame.prototype.Spec = nil
SkyUnitFrame.prototype.TS = nil
SkyUnitFrame.prototype.tO = {X = 0, Y = 0}
SkyUnitFrame.prototype.Txt = nil

SkyUnitFrame.prototype.IsCasting = false
SkyUnitFrame.prototype.CastIsChanneled = false
SkyUnitFrame.prototype.CastEnd = nil
SkyUnitFrame.prototype.CastDuration = nil
SkyUnitFrame.prototype.Spell = nil

SkyUnitFrame.prototype.IncomingHeals = 0

SkyUnitFrame.prototype.AuraBars = {}

local UpdateInterval = 0.2
SkyUnitFrame.prototype.TimeSinceLastUpdate = 0
SkyUnitFrame.prototype.cd_i = 0


function SkyUnitFrame.prototype:init(name, unit)

	self.Name = name
	local frameSpec
	if unit == "player" then frameSpec = SkyUI.Specs.UnitFrames.Frames.Player
	elseif unit == "target" then frameSpec = SkyUI.Specs.UnitFrames.Frames.Target end
	self.RT = frameSpec.RT
	self.X = frameSpec.X
	self.Y = frameSpec.Y
	self.W = frameSpec.W
	self.H = frameSpec.H
	self.T = SkyUI.Specs.UnitFrames.Unit.Textures
	self.Txt = SkyUI.Specs.UnitFrames.Unit.Text

	self.TS = SkyUI.Specs.UnitFrames.TextureSheet
	if SkyUI.Specs.UnitFrames.TextureOffset then self.tO = SkyUI.Specs.UnitFrames.TextureOffset end
	
 self.Unit = unit


 self.Health = UnitHealth(self.Unit)
 self.Power = UnitPower(self.Unit)
	self.TargetGUID = UnitGUID(self.Unit .. "target")

 self:CreateFrame()
	
	if unit == "target" then self.TexturesReversed = true end
 self:AddTextures()
	
	
	self.F.Clickable = CreateFrame("Button", self.BaseName .. self.Name .. "Clickable", self.F, "SecureUnitButtonTemplate")

	self.F.Clickable:EnableMouse(true)
	self.F.Clickable:RegisterForClicks("AnyUp")
	self.F.Clickable:SetAttribute("type1", "target")
	self.F.Clickable:SetAttribute("type2", "menu")
	self.F.Clickable:SetAttribute("unit", self.Unit)
	self.F.Clickable:SetAllPoints(self.F)
	if self.Unit == "player" then self.F.Clickable.menu = function(self) ToggleDropDownMenu(1, 1, PlayerFrameDropDown, self, 0 ,0) end
	elseif self.Unit == "target" then self.F.Clickable.menu = function(self) ToggleDropDownMenu(1, 1, _G[TargetFrame:GetName().."DropDown"], self, 0 ,0) end end
 self.F.Clickable:SetScript("OnEnter", self.OnEnter)
 self.F.Clickable:SetScript("OnLeave", self.OnLeave)


	self.F.CastBar:Hide()
	self.F.Cast:Hide()
	self.F.CastIconOverlay:Hide()
	
 if self.Txt then self:AddText() end -- Add any frame text/labels if provided
	self.F.UnitName:SetText(UnitName(self.Unit))
	self.F.UnitName:SetAlpha(0)
	self.F.CDSpannerL:SetAlpha(0)
	self.F.CDSpannerS:SetAlpha(0)
	self.F.CDSpannerR:SetAlpha(0)

 self.F.Portrait = self.F:CreateTexture(self.BaseName .. self.Name .. "Portrait", "ARTWORK")
 self.F.Portrait:SetWidth(39)
 self.F.Portrait:SetHeight(39)
 if self.TexturesReversed then
	 self.F.Portrait:SetPoint("TOPRIGHT", self.F, -5, -4)
	 self.F.Portrait:SetTexCoord(1, 0, 1, 1, 0, 0, 0, 1)
	else self.F.Portrait:SetPoint("TOPLEFT", self.F, 5, -4) end
	self.F.Portrait:SetDrawLayer("OVERLAY", 7)
 self.F.Portrait:Show()
-- 	self.F.Portrait:SetTexCoord(0.10, 0.90, 0.10, 0.90)
 SetPortraitTexture(self.F.Portrait, self.Unit)


 self.F.ClassIcon = self.F:CreateTexture(self.BaseName .. self.Name .. "ClassIcon", "OVERLAY")
	self.F.ClassIcon:SetSize(24, 24)
	self.F.ClassIcon:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
 if self.TexturesReversed then
	 self.F.ClassIcon:SetPoint("TOPRIGHT", self.F, -43, -22)
	else self.F.ClassIcon:SetPoint("TOPLEFT", self.F, 43, -22) end

 self:CreateAuraTextures()

	self:UpdateVertBar(self.F.IncomingHealth, 25, UnitHealthMax(self.Unit), self.T.IncomingHealth)


--	self.F:RegisterEvent("UNIT_PORTRAIT_UPDATE")
--	self.F:RegisterEvent("UNIT_MODEL_CHANGED")
 self.F:RegisterEvent("PLAYER_ENTERING_WORLD")

 self.F:RegisterEvent("UNIT_DISPLAYPOWER")
	self.F:RegisterEvent("UNIT_NAME_UPDATE")

--	self.F:RegisterEvent("UNIT_SPELLCAST_SENT")
	self.F:RegisterEvent("UNIT_SPELLCAST_START")
	self.F:RegisterEvent("UNIT_SPELLCAST_STOP")
	
	self.F:RegisterEvent("UNIT_SPELLCAST_FAILED")
	self.F:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")

	self.F:RegisterEvent("UNIT_SPELLCAST_DELAYED")
	self.F:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	
	self.F:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
	self.F:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
	self.F:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")

	self.F:RegisterEvent("UNIT_HEAL_PREDICTION")

 self.F:RegisterEvent("UNIT_AURA")

 self.F:SetScript("OnEvent", self.EventManager)
 self.F:SetScript("OnUpdate", self.Update)

end

function SkyUnitFrame.prototype:OnEnter(motion)
	self:GetParent().UnitName:SetAlpha(1)
	self:GetParent().CDSpannerL:SetAlpha(1)
	self:GetParent().CDSpannerS:SetAlpha(1)
	self:GetParent().CDSpannerR:SetAlpha(1)
end
function SkyUnitFrame.prototype:OnLeave(motion)
	self:GetParent().UnitName:SetAlpha(0)
	self:GetParent().UnitName:SetAlpha(0)
	self:GetParent().CDSpannerL:SetAlpha(0)
	self:GetParent().CDSpannerS:SetAlpha(0)
	self:GetParent().CDSpannerR:SetAlpha(0)
end

--/run local m,f=GetMouseFocus(),CnB or CreateFrame("Button","CnB",nil,"SecureActionButtonTemplate") f:SetAttribute("type","cancelaura") f:SetAttribute("unit","player") f:SetAttribute("spell",m and m._buff and m._buff.name)
--/click CnB

local function updateTooltip(self)
	if( GameTooltip:IsOwned(self) ) then
		GameTooltip:SetUnitAura(self.TT.Unit, self.TT.Index, self.TT.Filter)
	end
end

local function showTooltip(self)
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
	GameTooltip:SetUnitAura(self.TT.Unit, self.TT.Index, self.TT.Filter)
	self:SetScript("OnUpdate", updateTooltip)
end

local function hideTooltip(self)
	self:SetScript("OnUpdate", nil)
	GameTooltip:Hide()
end


function SkyUnitFrame.prototype:CreateAuraFrame(n, i, t)

 local f = CreateFrame("Frame", self.BaseName .. self.Name .. n .. "Frame" .. i, self.F)
	f:EnableMouse(true)
	
	if self.TexturesReversed then t.RT = "TOPRIGHT"
	else t.RT = "TOPLEFT" end

	if self.TexturesReversed then f:SetPoint(t.RT, -t.X - self.tO.X, t.Y + self.tO.Y)
	else f:SetPoint("TOPLEFT", t.X + self.tO.X, t.Y + self.tO.Y) end
	f:SetSize(t.W, t.H)
	f:SetFrameLevel(5)
		
	local a = f:CreateTexture()
	a:SetAllPoints(f)
--	a:SetTexture(1, 0, 0, 1)
	a:SetTexCoord(0.1, 0.9, 0.1, 0.9)
	f.texture = a

	f:SetScript("OnEnter", showTooltip)
 f:SetScript("OnLeave", hideTooltip)
		
	f.TT = nil
 f:Hide()
	
	self.F[n .. "Frame" .. i] = f
end

function SkyUnitFrame.prototype:CreateAuraTextures()
 local a, ad, b, d, bb, db, t = self.T.AuraBuff, self.T.AuraDebuff, self.T.Buff, self.T.Debuff, self.T.BuffBar, self.T.DebuffBar, {}
	
--	for i = 0, 12, 1 do
--	 local ii = i + 1
--  t["AuraBG" .. ii] = { X = 39 - 20 * (i % 2) - 20 * (math.floor(i / 2)), Y = -90.5 + 20 * (math.floor(i / 2)), tX = 182, tY = 374, W = 21, H = 21, L = "BACKGROUND" }
--	end

 for i=1, 8 do
	 local ii = i - 1
  t["BuffBar" .. i] = { X = bb.X, Y = bb.Y + ii * 17, tX = bb.tX, tY = bb.tY, W = bb.W, H = bb.H, L = bb.L }
  t["BuffLife" .. i] = { X = b.X, Y = b.Y + ii * 17, tX = b.tX, tY = b.tY, W = b.W, H = b.H, L = b.L }
		self:CreateAuraFrame("Buff", i, { X = a.X + 1, Y = a.Y + 17 + ii * 17 - 1, tX = a.tX, tY = a.tY, W = a.W - 2, H = a.H - 2, L = "OVERLAY", Clr = SkyUI.Clr.Transparent })
--  t["BuffIcon" .. i] = 

  t["DebuffBar" .. i] = { X = db.X, Y = db.Y - ii * 17, tX = db.tX, tY = db.tY, W = db.W, H = db.H, L = db.L }
  t["DebuffLife" .. i] = { X = d.X, Y = d.Y - ii * 17, tX = d.tX, tY = d.tY, W = d.W, H = d.H, L = d.L }
		self:CreateAuraFrame("Debuff", i, { X = ad.X + 1, Y = ad.Y - 16 - ii * 17 - 1, tX = ad.tX, tY = ad.tY, W = ad.W - 2, H = ad.H - 2, L = "OVERLAY", Clr = SkyUI.Clr.Transparent })
--  t["DebuffIcon" .. i] = 
	end

 for i=1, 12 do
	 local ii = i - 1
  t["AuraBuff" .. i] = { X = a.X + (math.floor(ii / 2) * 17), Y = a.Y - ((ii % 2) * 17), tX = a.tX, tY = a.tY, W = a.W, H = a.H, L = a.L }
		self:CreateAuraFrame("AuraBuff", i, { X = a.X + (math.floor(ii / 2) * 17) + 1, Y = a.Y - ((ii % 2) * 17) - 1, tX = a.tX, tY = a.tY, W = a.W - 2, H = a.H - 2, L = "OVERLAY", Clr = SkyUI.Clr.Transparent })
--  t["AuraBuffIcon" .. i] = 

  t["AuraDebuff" .. i] = { X = ad.X + (math.floor(ii / 3) * 17), Y = ad.Y + ((ii % 3) * 17), tX = ad.tX, tY = ad.tY, W = ad.W, H = ad.H, L = ad.L }
		self:CreateAuraFrame("AuraDebuff", i, { X = ad.X + (math.floor(ii / 3) * 17) + 1, Y = ad.Y + ((ii % 3) * 17) - 1, tX = ad.tX, tY = ad.tY, W = ad.W - 2, H = ad.H - 2, L = "OVERLAY", Clr = SkyUI.Clr.Transparent })
--  t["AuraDebuffIcon" .. i] = 

	end
	
	self:AddTextures(t)

-- self:CreateAuraFrames("BuffIcon", 8)
-- self:CreateAuraFrames("DebuffIcon", 8)
-- self:CreateAuraFrames("AuraBuffIcon", 12)
-- self:CreateAuraFrames("AuraDebuffIcon", 12)

end

function SkyUnitFrame.prototype:UpdateVertBar(t, curVal, maxVal, v, YOffset) -- , textureOffset, reversedTexture
 if curVal == 0 then curVal = 1 end
 if maxVal == 0 or t == nil then return end
	if curVal > maxVal then curVal = maxVal end
	if not YOffset then YOffset = 0 end
	
	local p = curVal / maxVal;

	local newHeight = v.H * p
	local dif = v.H - newHeight

 local g = self.TS
	
	local x1, x2, y1, y2 = v.tX / g.W, (v.tX + v.W) / g.W, (v.tY+dif) / g.H, (v.tY + v.H) / g.H

 point, relativeTo, relativePoint, xOfs, yOfs = t:GetPoint()

	if self.TexturesReversed then
	 t:SetTexCoord(x2, y1, x2, y2, x1, y1, x1, y2)
 	t:SetPoint(relativePoint, t:GetParent(), -v.X - self.tO.X, v.Y + self.tO.Y - dif + YOffset)
	else
	 t:SetTexCoord(x1, x2, y1, y2)
 	t:SetPoint(relativePoint, t:GetParent(), v.X + self.tO.X, v.Y + self.tO.Y - dif + YOffset)
	end
	
	t:SetSize(v.W, newHeight)
end

function SkyUnitFrame.prototype:UpdateCDSpanner(w)
	self.F.CDSpannerS:SetWidth(w + 1)
	if self.TexturesReversed then self.F.CDSpannerR:SetPoint("TOPRIGHT", -self.T.CDSpannerR.X - self.tO.X - w, self.T.CDSpannerR.Y + self.tO.Y)
 else self.F.CDSpannerR:SetPoint("TOPLEFT", self.T.CDSpannerR.X + self.tO.X + w, self.T.CDSpannerR.Y + self.tO.Y) end
end

function SkyUnitFrame.prototype:UpdateUnitName()
 	self.F.UnitName:SetText(UnitName(self.Unit))
		local nameWidth = self.F.UnitName:GetStringWidth() + 14
		self:UpdateCDSpanner(nameWidth)
end

function SkyUnitFrame.prototype:UpdateAuraBars() -- ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  ! ** !  --
-- Start .. Duration .. Expires
 local g = self.TS
	
 for k, v in pairs(self.AuraBars) do
		local durationRemaining = v.Expires - GetTime()
  self:UpdateVertBar(self.F[k], durationRemaining, v.Duration, v.T, v.Offset)
	end
end

-- **************  UPDATE ! UPDATE ! UPDATE ! UPDATE ! UPDATE ! UPDATE ! UPDATE ! UPDATE ! UPDATE ! UPDATE ! UPDATE ! ********************************** ! UPDATE ! UPDATE --
function SkyUnitFrame.prototype:Update(elapsed)
 local sui = self.sui

 if sui.Spell then sui:CastUpdate() end

 if sui.TimeSinceLastUpdate < UpdateInterval then
  sui.TimeSinceLastUpdate = sui.TimeSinceLastUpdate + elapsed
		return
	end
	
 sui.TimeSinceLastUpdate = 0
	
	local guid = UnitGUID(sui.Unit)
	local targetGUID = UnitGUID(sui.Unit .. "target")
	local health = UnitHealth(sui.Unit)
	local power = UnitPower(sui.Unit)

 if not guid then
	 self:SetAlpha(0)
	elseif( guid ~= sui.GUID ) then
	 if not sui.GUID then self:SetAlpha(1) end
	 SetPortraitTexture(sui.F.Portrait, sui.Unit)
 	local powerType, powerToken, _, _, _ = UnitPowerType(sui.Unit)
  self.Power:SetVertexColor(PowerBarColor[powerType].r, PowerBarColor[powerType].g, PowerBarColor[powerType].b)
  sui:UpdateVertBar(self.Health, health, UnitHealthMax(sui.Unit), sui.T.Health)
  sui:UpdateVertBar(self.Power, power, UnitPowerMax(sui.Unit), sui.T.Power)
		sui:UpdateUnitName()
  sui:AuraUpdates()
		
--  local classToken = select(2, UnitClass(sui.Unit))
--	 self.ClassIcon:SetTexCoord(CLASS_ICON_TCOORDS[classToken][1], CLASS_ICON_TCOORDS[classToken][2], CLASS_ICON_TCOORDS[classToken][3], CLASS_ICON_TCOORDS[classToken][4])


		if UnitIsPlayer(sui.Unit) then			
			local t = CLASS_ICON_TCOORDS[select(2,UnitClassBase(sui.Unit))]
			if t then
				self.ClassIcon:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
				self.ClassIcon:SetTexCoord(unpack(t))
			end
		else
			self.ClassIcon:SetTexCoord(0,0,0,0)
		end

	else
		if sui.Health ~= health then sui:UpdateVertBar(self.Health, health, UnitHealthMax(sui.Unit), sui.T.Health) end
  if sui.Power ~= power then sui:UpdateVertBar(self.Power, power, UnitPowerMax(sui.Unit), sui.T.Power) end
	end

	sui.GUID = guid
	sui.TargetGUID = targetGUID
	sui.Health = health
	sui.Power = power

	if sui.cd_i < 5 then
	 sui.cd_i = sui.cd_i + 1
		return
	end
	sui.cd_i = 0
	
	if sui.Unit == "target" and UnitIsEnemy("player", "target") then sui.F.Health:SetVertexColor(SkyUI.Clr.HealthHostile.r, SkyUI.Clr.HealthHostile.g, SkyUI.Clr.HealthHostile.b, SkyUI.Clr.HealthHostile.a)
	else sui.F.Health:SetVertexColor(SkyUI.Clr.HealthFriendly.r, SkyUI.Clr.HealthFriendly.g, SkyUI.Clr.HealthFriendly.b, SkyUI.Clr.HealthFriendly.a) end

	sui:UpdateAuraBars()

end

function SkyUnitFrame.prototype:CastStart()
 self.IsCasting = true
	-- START ... currentTime .. END
	-- (END - currentTime) / Duration = Percent Left
 	
	local spell, rank, displayName, icon, startTime, endTime, isTradeSkill = UnitCastingInfo(self.Unit)
	if not (spell) then
	 spell, rank, displayName, icon, startTime, endTime = UnitChannelInfo(self.Unit)
	 self.CastIsChanneled = true;
	end
 if not (spell) then return end

	self.Spell = spell
	self.CastEnd = endTime / 1000
 self.CastDuration = (endTime - startTime) / 1000

 self.F.CastBar:Show()
	self.F.Cast:Show()
	self.F.CastIconOverlay:Show()
 self.F.CastIconOverlay:SetTexture(icon)
 self.F.CastIconOverlay:SetTexCoord(0.1, 0.9, 0.1, 0.9)

 self.F.UnitName:Hide()
	self.F.CDSpannerL:Hide()
	self.F.CDSpannerS:Hide()
	self.F.CDSpannerR:Hide()

end

function SkyUnitFrame.prototype:CastUpdate()
 if not self.Spell then return end
	local p, v, t = (self.CastEnd - GetTime()) / self.CastDuration, self.T.Cast, self.F.Cast
	if self.CastIsChanneled then
	
	else p = 1 - p end
	
 local newWidth = v.W * p
	local dif = v.W - newWidth

 local g = self.TS
	

	local x1, x2, y1, y2 = v.tX / g.W, (v.tX + newWidth) / g.W, v.tY / g.H, (v.tY + v.H) / g.H

 point, relativeTo, relativePoint, xOfs, yOfs = t:GetPoint()

	if self.TexturesReversed then
	 t:SetTexCoord(x2, y1, x2, y2, x1, y1, x1, y2)
 	t:SetPoint(relativePoint, t:GetParent(), -v.X - self.tO.X, v.Y + self.tO.Y)
	else
	 t:SetTexCoord(x1, x2, y1, y2)
 	t:SetPoint(relativePoint, t:GetParent(), v.X + self.tO.X, v.Y + self.tO.Y)
	end
	
	t:SetSize(newWidth, v.H)

	
end

function SkyUnitFrame.prototype:IncomingHealsUpdate(evt, ...)
 if ... ~= self.Unit then return end

	self.IncomingHeals = UnitGetIncomingHeals(self.Unit) or 0
 if self.IncomingHeals ~= 0 then self.IncomingHeals = self.IncomingHeals + UnitHealth(self.Unit) end
	if self.IncomingHeals >= UnitHealthMax(self.Unit) then self.IncomingHeals = 0 end
 self:UpdateVertBar(self.F.IncomingHealth, self.IncomingHeals, UnitHealthMax(self.Unit), self.T.Health)
  
end

function SkyUnitFrame.prototype:CastStop()
 self.IsCasting = false
 self.Spell = nil
	self.CastEnd = nil
 self.CastDuration = nil
	self.CastIsChanneled = false;

 self.F.CastBar:Hide()
	self.F.Cast:Hide()
	self.F.CastIconOverlay:Hide()

 self.F.UnitName:Show()
	self.F.CDSpannerL:Show()
	self.F.CDSpannerS:Show()
	self.F.CDSpannerR:Show()
end

local function compareDurations(a,b)
 if not a[5] or not b[5] then return a[1] < b[1]
 else return a[5] < b[5] end
end

function SkyUnitFrame.prototype:AuraUpdates()
 
-- local buffs, debuffs, aurabuffs, auradebuffs = {}, {}, {}, {} -- 

 local auras = {}

-- local i, b, d, ab, ad = 1, 1, 1, 1, 1
 for i = 1, 20 do
	 bName, _, bIcon, _, bDebuffType, bDuration, bExpirationTime, _, bIsStealable, _, bSpellId = UnitAura(self.Unit, i, "HELPFUL") 
	 dName, _, dIcon, _, dDebuffType, dDuration, dExpirationTime, _, dIsStealable, _, dSpellId = UnitAura(self.Unit, i, "HARMFUL") 
  if bName then
		 if bDuration ~= 0 and bDuration < 100 then
			 auras[#auras + 1] = { 1, bName, bIcon, bDuration, bExpirationTime, bIsStealable, bSpellId, i }
		 else
			 auras[#auras + 1] = { 2, bName, bIcon, bDuration, bExpirationTime, bIsStealable, bSpellId, i }
		 end
		end

  if dName then
		 if dDuration ~= 0 and dDuration < 100 then
			 auras[#auras + 1] = { 3, dName, dIcon, dDuration, dExpirationTime, dIsStealable, dSpellId, i }
		 else
			 auras[#auras + 1] = { 4, dName, dIcon, dDuration, dExpirationTime, dIsStealable, dSpellId, i }
		 end
		end
		
		
		
		

		for i = 1, 12 do
		 if i < 9 then
			 self.F["BuffBar" .. i]:SetAlpha(0)
			 self.F["BuffLife" .. i]:SetAlpha(0)
			 self.F["DebuffBar" .. i]:SetAlpha(0)
			 self.F["DebuffLife" .. i]:SetAlpha(0)
				
				self.F["BuffFrame" .. i].Index = nil
    self.F["BuffFrame" .. i]:Hide()
				self.F["DebuffFrame" .. i].Index = nil
    self.F["DebuffFrame" .. i]:Hide()
			end
			self.F["AuraBuff" .. i]:SetAlpha(0)
			self.F["AuraDebuff" .. i]:SetAlpha(0)

   self.F["AuraBuffFrame" .. i].Index = nil
   self.F["AuraBuffFrame" .. i]:Hide()
   self.F["AuraDebuffFrame" .. i].Index = nil
   self.F["AuraDebuffFrame" .. i]:Hide()
		end
		
		local bb, b, db, d = 1, 1, 1, 1
		self.AuraBars = {}
		
		for i, k in ipairs(auras) do
		 if k[1] == 1 and bb < 8 and k[4] > 10 then
--    self.Buffs[bb] = k
			 if self.F["BuffBar" .. bb] then
			 	self.F["BuffBar" .. bb]:SetAlpha(1)
			 	self.F["BuffLife" .. bb]:SetAlpha(1)
     self.F["BuffFrame" .. bb]:Show()
     self.F["BuffFrame" .. bb].TT = { Index = k[8], Unit = self.Unit, Filter = "HELPFUL" }
			 	self.F["BuffFrame" .. bb].texture:SetTexture(k[3])
			 	self.AuraBars["BuffLife" .. bb] = { Duration = k[4], Expires = k[5], T = self.T.Buff, Offset = (bb - 1) * 17 }
			  bb = bb + 1
			 end
			elseif k[1] == 2 or bb > 7 or k[4] < 11 then
			 if self.F["AuraBuff" .. b] then
				 self.F["AuraBuff" .. b]:SetAlpha(1)
     self.F["AuraBuffFrame" .. b]:Show()
     self.F["AuraBuffFrame" .. b].TT = { Index = k[8], Unit = self.Unit, Filter = "HELPFUL" }
				 self.F["AuraBuffFrame" .. b].texture:SetTexture(k[3])
			  b = b + 1
				end
			elseif k[1] == 3 and db < 8 and k[4] > 10 then
--    self.Debuffs[db] = k
			 if self.F["DebuffBar" .. db] then
				 self.F["DebuffBar" .. db]:SetAlpha(1)
				 self.F["DebuffLife" .. db]:SetAlpha(1)
     self.F["DebuffFrame" .. db]:Show()
     self.F["DebuffFrame" .. db].TT = { Index = k[8], Unit = self.Unit, Filter = "HARMFUL" }
				 self.F["DebuffFrame" .. db].texture:SetTexture(k[3])
				 self.AuraBars["DebuffLife" .. db] = { Duration = k[4], Expires = k[5], T = self.T.Debuff, Offset = -(db - 1) * 17 }
			  db = db + 1
				end
			elseif k[1] == 4 or gb > 7 or k[4] < 11 then
			 if self.F["AuraDebuff" .. d] then
				 self.F["AuraDebuff" .. d]:SetAlpha(1)
     self.F["AuraDebuffFrame" .. d]:Show()
     self.F["AuraDebuffFrame" .. d].TT = { Index = k[8], Unit = self.Unit, Filter = "HARMFUL" }
				 self.F["AuraDebuffFrame" .. d].texture:SetTexture(k[3])
			  d = d + 1
				end
			end
			
		end
--  self.F["AuraBuffIcon" .. i]:SetTexture(icon)
--  self.F["AuraBuffIcon" .. i]:SetTexCoord(0.1, 0.9, 0.1, 0.9)
		
--  self.F["AuraBuffIcon" .. i]:SetAlpha(1)
  if not bName and not dName then break end
 end
 
	table.sort(auras, compareDurations)
--	table.sort(debuffs, compareDurations)
--	table.sort(aurabuffs, compareDurations)
--	table.sort(auradebuffs, compareDurations)
 for i, b in ipairs(auras) do
	 local s = i
		for j, k in ipairs(b) do if k then s = s .. ", " .. k end end
--	 print(s)
 end


end

function SkyUnitFrame.prototype:EventManager(evt, ...)
 local sui = self.sui
 if evt == "PLAYER_ENTERING_WORLD" then
		sui:UpdateVertBar(self.Health, UnitHealth(sui.Unit), UnitHealthMax(sui.Unit), sui.T.Health)
		sui:UpdateVertBar(self.Power, UnitPower(sui.Unit), UnitPowerMax(sui.Unit), sui.T.Power)	

	elseif evt == "UNIT_DISPLAYPOWER" then
 	local powerType, powerToken, _, _, _ = UnitPowerType(sui.Unit)
  self.Power:SetVertexColor(PowerBarColor[powerType].r, PowerBarColor[powerType].g, PowerBarColor[powerType].b)
	elseif evt == "UNIT_NAME_UPDATE" then
	 sui.F.UnitName:SetText(UnitName(sui.Unit))
	elseif evt == "UNIT_SPELLCAST_START" or evt == "UNIT_SPELLCAST_CHANNEL_START" then sui:CastStart()
	elseif evt == "UNIT_SPELLCAST_STOP" or evt == "UNIT_SPELLCAST_CHANNEL_STOP" then sui:CastStop()
	
	elseif evt == "UNIT_HEAL_PREDICTION" then sui:IncomingHealsUpdate(evt, ...)
 
	elseif evt == "UNIT_AURA" then sui:AuraUpdates(evt, ...)
--	self.F:RegisterEvent("UNIT_SPELLCAST_START")
--	self.F:RegisterEvent("UNIT_SPELLCAST_STOP")
	
--	self.F:RegisterEvent("UNIT_SPELLCAST_FAILED")
--	self.F:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")

--	self.F:RegisterEvent("UNIT_SPELLCAST_DELAYED")
--	self.F:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	
--	self.F:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
--	self.F:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
--	self.F:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")

 end
end




SkyUI.PlayerFrame = SkyUnitFrame:new("PlayerFrame", "player")
SkyUI.TargetFrame = SkyUnitFrame:new("TargetFrame", "target")




 PlayerFrame:Hide()
	PlayerFrame:UnregisterAllEvents()
	
	TargetFrame:Hide()
	TargetFrame:UnregisterAllEvents()

	ComboFrame:Hide()
	ComboFrame:UnregisterAllEvents()







